/**********************************************************************
**
** Definition of TQLineEdit widget class
**
** Created : 941011
**
** Copyright (C) 2010 Timothy Pearson and (C) 1992-2008 Trolltech ASA.
**
** This file is part of the widgets module of the TQt GUI Toolkit.
**
** This file may be used under the terms of the GNU General
** Public License versions 2.0 or 3.0 as published by the Free
** Software Foundation and appearing in the files LICENSE.GPL2
** and LICENSE.GPL3 included in the packaging of this file.
** Alternatively you may (at your option) use any later version
** of the GNU General Public License if such license has been
** publicly approved by Trolltech ASA (or its successors, if any)
** and the KDE Free TQt Foundation.
**
** Please review the following information to ensure GNU General
** Public Licensing requirements will be met:
** http://trolltech.com/products/qt/licenses/licensing/opensource/.
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://trolltech.com/products/qt/licenses/licensing/licensingoverview
** or contact the sales department at sales@trolltech.com.
**
** This file may be used under the terms of the Q Public License as
** defined by Trolltech ASA and appearing in the file LICENSE.TQPL
** included in the packaging of this file.  Licensees holding valid TQt
** Commercial licenses may use this file in accordance with the TQt
** Commercial License Agreement provided with the Software.
**
** This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
** INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE. Trolltech reserves all rights not granted
** herein.
**
**********************************************************************/

#ifndef TQLINEEDIT_H
#define TQLINEEDIT_H

struct TQLineEditPrivate;

class TQValidator;
class TQPopupMenu;

#ifndef TQT_H
#include "tqframe.h"
#include "tqstring.h"
#endif // TQT_H

#ifndef TQT_NO_LINEEDIT

class TQTextParagraph;
class TQTextCursor;

class TQ_EXPORT TQLineEdit : public TQFrame
{
    Q_OBJECT
    TQ_OBJECT
    TQ_ENUMS( EchoMode )
    Q_PROPERTY( TQString text READ text WRITE setText )
    Q_PROPERTY( int maxLength READ maxLength WRITE setMaxLength )
    Q_PROPERTY( bool frame READ frame WRITE setFrame )
    Q_PROPERTY( EchoMode echoMode READ echoMode WRITE setEchoMode )
    Q_PROPERTY( TQString displayText READ displayText )
    Q_PROPERTY( int cursorPosition READ cursorPosition WRITE setCursorPosition )
    Q_PROPERTY( Qt::Alignment tqalignment READ alignmentProp WRITE tqsetAlignmentProp )
    Q_PROPERTY( bool edited READ edited WRITE setEdited DESIGNABLE false )
    Q_PROPERTY( bool modified READ isModified )
    Q_PROPERTY( bool hasMarkedText READ hasMarkedText DESIGNABLE false )
    Q_PROPERTY( bool hasSelectedText READ hasSelectedText )
    Q_PROPERTY( TQString markedText READ markedText DESIGNABLE false )
    Q_PROPERTY( TQString selectedText READ selectedText )
    Q_PROPERTY( bool dragEnabled READ dragEnabled WRITE setDragEnabled )
    Q_PROPERTY( bool readOnly READ isReadOnly WRITE setReadOnly )
    Q_PROPERTY( bool undoAvailable READ isUndoAvailable )
    Q_PROPERTY( bool redoAvailable READ isRedoAvailable )
    Q_PROPERTY( TQString inputMask READ inputMask WRITE setInputMask )
    Q_PROPERTY( bool acceptableInput READ hasAcceptableInput )

public:
    TQLineEdit( TQWidget* parent, const char* name=0 );
    TQLineEdit( const TQString &, TQWidget* parent, const char* name=0 );
    TQLineEdit( const TQString &, const TQString &, TQWidget* parent, const char* name=0 );
    ~TQLineEdit();

    TQString text() const;

    TQString displayText() const;

    int maxLength() const;

    bool frame() const;

    enum EchoMode { Normal, NoEcho, Password };
    EchoMode echoMode() const;

    bool isReadOnly() const;

    const TQValidator * validator() const;

    TQSize tqsizeHint() const;
    TQSize tqminimumSizeHint() const;

    int cursorPosition() const;
    bool validateAndSet( const TQString &, int, int, int ); // obsolete

    int tqalignment() const;
    inline Qt::Alignment alignmentProp() const { return (Qt::Alignment)tqalignment(); }
    inline virtual void tqsetAlignmentProp( Qt::Alignment al ) { tqsetAlignment((int)al); }

#ifndef TQT_NO_COMPAT
    void cursorLeft( bool mark, int steps = 1 ) { cursorForward( mark, -steps ); }
    void cursorRight( bool mark, int steps = 1 ) { cursorForward( mark, steps ); }
#endif
    void cursorForward( bool mark, int steps = 1 );
    void cursorBackward( bool mark, int steps = 1 );
    void cursorWordForward( bool mark );
    void cursorWordBackward( bool mark );
    void backspace();
    void del();
    void home( bool mark );
    void end( bool mark );

    bool isModified() const;
    void clearModified();

    bool edited() const; // obsolete, use isModified()
    void setEdited( bool ); // obsolete, use clearModified()

    bool hasSelectedText() const;
    TQString selectedText() const;
    int selectionStart() const;

    bool isUndoAvailable() const;
    bool isRedoAvailable() const;

#ifndef TQT_NO_COMPAT
    bool hasMarkedText() const { return hasSelectedText(); }
    TQString markedText() const { return selectedText(); }
#endif

    bool dragEnabled() const;

    TQString inputMask() const;
    void setInputMask( const TQString &inputMask );
    bool hasAcceptableInput() const;

public Q_SLOTS:
    virtual void setText( const TQString &);
    virtual void selectAll();
    virtual void deselect();
    virtual void clearValidator();
    virtual void insert( const TQString &);
    virtual void clear();
    virtual void undo();
    virtual void redo();
    virtual void setMaxLength( int );
    virtual void setFrame( bool );
    virtual void setEchoMode( EchoMode );
    virtual void setReadOnly( bool );
    virtual void setValidator( const TQValidator * );
    virtual void setFont( const TQFont & );
    virtual void setPalette( const TQPalette & );
    virtual void setSelection( int, int );
    virtual void setCursorPosition( int );
    virtual void tqsetAlignment( int flag );
#ifndef TQT_NO_CLIPBOARD
    virtual void cut();
    virtual void copy() const;
    virtual void paste();
#endif
    virtual void setDragEnabled( bool b );

Q_SIGNALS:
    void textChanged( const TQString &);
    void returnPressed();
    void lostFocus();
    void selectionChanged();

protected:
    bool event( TQEvent * );
    void mousePressEvent( TQMouseEvent * );
    void mouseMoveEvent( TQMouseEvent * );
    void mouseReleaseEvent( TQMouseEvent * );
    void mouseDoubleClickEvent( TQMouseEvent * );
    void keyPressEvent( TQKeyEvent * );
    void imStartEvent( TQIMEvent * );
    void imComposeEvent( TQIMEvent * );
    void imEndEvent( TQIMEvent * );
    void focusInEvent( TQFocusEvent * );
    void focusOutEvent( TQFocusEvent * );
    void resizeEvent( TQResizeEvent * );
    void drawContents( TQPainter * );
#ifndef TQT_NO_DRAGANDDROP
    void dragEnterEvent( TQDragEnterEvent * );
    void dragMoveEvent( TQDragMoveEvent *e );
    void dragLeaveEvent( TQDragLeaveEvent *e );
    void dropEvent( TQDropEvent * );
#endif
    void contextMenuEvent( TQContextMenuEvent * );
    bool sendMouseEventToInputContext( TQMouseEvent *e );
    virtual TQPopupMenu *createPopupMenu();
    void windowActivationChange( bool );
#ifndef TQT_NO_COMPAT
    void repaintArea( int, int ) { update(); }
#endif

private Q_SLOTS:
    void clipboardChanged();

public:
    void setPasswordChar( TQChar c ); // internal obsolete
    TQChar passwordChar() const; // obsolete internal
    int characterAt( int, TQChar* ) const; // obsolete
    bool getSelection( int *, int * ); // obsolete

private:
    friend struct TQLineEditPrivate;
    TQLineEditPrivate * d;

private:	// Disabled copy constructor and operator=
#if defined(TQ_DISABLE_COPY)
    TQLineEdit( const TQLineEdit & );
    TQLineEdit &operator=( const TQLineEdit & );
#endif
};


#endif // TQT_NO_LINEEDIT

#endif // TQLINEEDIT_H
